//***************** (c) 2009 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : ADC_POT
// BOARD    : ZL28ARM
// COMPILER : WinARM 20060606
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Simple AD conversion. Input voltage is selected by potentiometer Pot4.
//    Result of conversion is transmitted to PC.//
//    
// CONNECTIONS :
// 	  RS232(PC) -> CON10(ZL28ARM)
//
//	SETTINGS:
//        Con13 : ADC4/POT4
//		  115200bps 8N1
//
//******************************************************************************
#include "board.h"
#include "utils.h"
#include "usart.h"
#include "adc.h"

int main(void)
{
char str[5];
volatile unsigned int i;
int ADCValue;

AT91F_PMC_EnablePeriphClock(AT91C_BASE_PMC, 1 << AT91C_ID_PIOA);
AT91F_RSTSetMode(AT91C_BASE_RSTC, AT91C_RSTC_URSTEN);

LCD_Initialize();
LCD_GoTo(0,0);
LCD_WriteText("ZL28ARM ADC_POT");
LCD_GoTo(0,1);
LCD_WriteText(" www.kamami.com");

USART_Init(115200); // USART initialization

USART_PutChar('\r');
USART_PutString("*************************\r");
USART_PutString("**   ZL28ARM ADC_POT   **\r");
USART_PutString("**    www.kamami.com   **\r");
USART_PutString("*************************\r");

ADC_Init(); // ADC initialization

// infinite loop
do{
  USART_PutString("Analog input value:");
  ADCValue = getADC();
  itoa(ADCValue, str);
  USART_PutString(str);
  USART_PutString("\r");
  
  for(i = 0; i < 0x1FFFF; i++);
}while(1);


return 0;


}
