//***************** (c) 2009 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : BUZZER
// BOARD    : ZL28ARM
// COMPILER : WinARM 20060606
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Simple sound generating.
//
//    CONNECTIONS:
//        PB0 (Con14) - SPK (Con12)
//
//******************************************************************************
#include "board.h"
//-------------------------------------
// Sound function
//-------------------------------------
void Sound(int duration, int pulses)
{
volatile int i,d;
int pin;
d = duration;
while(d--)
  {
  for(i = pulses ; i > 0; i--);
  pin = AT91F_PIO_GetOutputDataStatus(AT91C_BASE_PIOB);
  pin ^= 1;
  AT91F_PIO_ForceOutput(AT91C_BASE_PIOB, pin);
  }
}
//-------------------------------------
// main program
//-------------------------------------
int main(void)
{
volatile unsigned int i;

AT91F_PMC_EnablePeriphClock(AT91C_BASE_PMC, 1 << AT91C_ID_PIOB);
AT91F_RSTSetMode(AT91C_BASE_RSTC, AT91C_RSTC_URSTEN);

AT91F_PIO_CfgOutput(AT91C_BASE_PIOB, AT91C_PIO_PB0);
AT91F_PIO_OutputEnable(AT91C_BASE_PIOB, AT91C_PIO_PB0);
AT91F_PIO_CfgDirectDrive(AT91C_BASE_PIOB, AT91C_PIO_PB0);

LCD_Initialize();
LCD_GoTo(1,0);
LCD_WriteText("ZL28ARM BUZZER");
LCD_GoTo(1,1);
LCD_WriteText("www.kamami.com");

// Infinite loop
do{
  Sound(1000,400);			// play sound
  for(i = 0; i < 0xFFFFF; i++);
  Sound(1000,500);			// play sound
  for(i = 0; i < 0xFFFFF; i++);
  Sound(1000,600);			// play sound
  for(i = 0; i < 0xFFFFF; i++);
}while(1);
return 0;
}
//-------------------------------------
// End of file
//-------------------------------------
