#include "board.h"


void USART_Init(int baudrate)
{
AT91F_US0_CfgPMC();
AT91F_US0_CfgPIO();
AT91F_US_Configure(AT91C_BASE_US0, 47923200, AT91C_US_ASYNC_MODE, baudrate, 100);
AT91F_US_EnableRx(AT91C_BASE_US0);
AT91F_US_EnableTx(AT91C_BASE_US0);
}
//

char USART_GetChar(void)
{
while(!AT91F_US_RxReady(AT91C_BASE_US0));
return AT91F_US_GetChar(AT91C_BASE_US0);
}
//

void USART_PutChar(char c)
{
while(!AT91F_US_TxReady(AT91C_BASE_US0));
AT91F_US_PutChar(AT91C_BASE_US0, c);
}
//-------------------------------------
// Send string
//-------------------------------------
void USART_PutString(char * s)
{
while(*s)
	USART_PutChar(*s++);
}
//-------------------------------------
// Receive string
//-------------------------------------
void USART_GetString(char * s)
{
char c;
do{
  c = USART_GetChar();
  USART_PutChar(c);
  if(c=='\b')   // if backspace
    s--;
  else     
    *s++ = c;
  if(c == '\r') // if CR
    *s = 0;
}while(c != '\r');
}
//-------------------------------------
// Conver 8-bit value to hex
//-------------------------------------
char * Hex(char val, char*str)
{
*str = ((val >> 4) < 10 )?(val >> 4)+'0':(val >> 4)+'7';
*(str+1) = ((val & 0xF) < 10 )?(val & 0xF)+'0':(val & 0xF)+'7';
*(str+2) = 0;
return str;
}
//-------------------------------------
// End of file
//-------------------------------------
