//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : RTC_M41T00
// BOARD    : ZL28ARM 
// COMPILER : WinARM 20060606
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    M41T00 RTC example
//
// CONNECTIONS :
// 	  RS232(PC) -> CON10(ZL28ARM)
//	  A10(Con14) -> RTC_SDA(Con11)
// 	  A11(Con14) -> RTC_SCL(Con11)
//
//
// SETTINGS:
// 	  115200bps 8N1
//
//******************************************************************************
#include "board.h"
#include "lib_twi.h"
#include "usart.h"
#include "M41T00.h"
#include "HD44780.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//-------------------------------------
// main program
//-------------------------------------
int main(void)
{
volatile unsigned int j;
char str[5];
char StringBuffer[128];
DateTime RTC;
char choice;

AT91F_PMC_EnablePeriphClock(AT91C_BASE_PMC, 1 << AT91C_ID_PIOA);
AT91F_RSTSetMode(AT91C_BASE_RSTC, AT91C_RSTC_URSTEN);

LCD_Initialize();

USART_Init(115200);

USART_PutString("\r\r");
USART_PutString("********************************************\r");
USART_PutString("**              ZL28ARM RTC               **\r");
USART_PutString("**             www.kamami.com             **\r");
USART_PutString("********************************************\r");

LCD_GoTo(0,0);
LCD_WriteText("   ZL28ARM RTC");
LCD_GoTo(0,1);
LCD_WriteText(" www.kamami.com");

M41T00_Init();
M41T00_GetDateTime(&RTC);
USART_PutString("\rM41T00\r");
USART_PutString("Current time and date :");
sprintf(StringBuffer,"\r\tTime : %02d:%02d:%02d", RTC.Hours, RTC.Minutes, RTC.Seconds);
USART_PutString(StringBuffer);
sprintf(StringBuffer,"\r\tDate : %d/%02d/%02d", 2000 + RTC.Year, RTC.Month, RTC.Day);
USART_PutString(StringBuffer);

USART_PutString("\rChange date and time? [y/n]");
choice = USART_GetChar();
if(choice == 'y')
  {
  USART_PutString("\rSet hour : ");
  USART_GetString(str);
  RTC.Hours = atoi(str);

  USART_PutString("\rSet minute : ");
  USART_GetString(str);
  RTC.Minutes = atoi(str);

  USART_PutString("\rSet second : ");
  USART_GetString(str);
  RTC.Seconds = atoi(str);

  USART_PutString("\rSet day : ");
  USART_GetString(str);
  RTC.Day = atoi(str);

  USART_PutString("\rSet month : ");
  USART_GetString(str);
  RTC.Month = atoi(str);

  USART_PutString("\rSet year : ");
  USART_GetString(str); 
  RTC.Year = atoi(str);

  M41T00_SetDateTime(&RTC);
  }

  LCD_Clear();	
  
do{
	M41T00_GetDateTime(&RTC);
	USART_PutString("\rM41T00\r");
	USART_PutString("Current time and date :");
	sprintf(StringBuffer,"\r\tTime : %02d:%02d:%02d", RTC.Hours, RTC.Minutes, RTC.Seconds);
	USART_PutString(StringBuffer);
	LCD_WriteTextXY(StringBuffer + strlen("\r\tTime : "), 4, 0);
	sprintf(StringBuffer,"\r\tDate : %d/%02d/%02d", 2000 + RTC.Year, RTC.Month, RTC.Day);
	USART_PutString(StringBuffer);
	LCD_WriteTextXY(StringBuffer + strlen("\r\tDate : "), 3, 1);
	USART_PutString("\r-------------------------------------------");
	
	for(j = 0 ; j < 0x1F0000; j++);                
}while(1);

return 0;
}
//-------------------------------------
// main program
//-------------------------------------
