//***************** (c) 2009 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : TEMP_TC77
// BOARD    : ZL28ARM
// COMPILER : WinARM 20060606
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    TC77 Themperature Sensor Demo
//
// CONNECTIONS :
// 	  RS232(PC) -> CON10(ZL28ARM)
//	  
//	  CS1(Con14) -> CS(Con12)
//    SO0(Con14) -> SIO(Con12)
//	  CK0(Con14) -> SCK(Con12)
//
// SETTINGS:
// 	  115200bps 8N1
//
//******************************************************************************
#include "board.h"
#include "USART.h"
#include "HD44780.h"
#include "SPI.h"
#include "utils.h"

int main(void)
{
volatile unsigned int i;
char A1, A2;
char str[5];

signed short temp, fract;
char strTemp[3];

const char fractConst[] = {'0','1','1','2','3','3','4','4','5','6','6','7','8','8','9','9'};

AT91F_PMC_EnablePeriphClock(AT91C_BASE_PMC, 1 << AT91C_ID_PIOA);
AT91F_RSTSetMode(AT91C_BASE_RSTC, AT91C_RSTC_URSTEN);

USART_Init(115200);

LCD_Initialize();
LCD_GoTo(0,0);
LCD_WriteText("  ZL28ARM  TC77");
LCD_GoTo(0,1);
LCD_WriteText(" www.kamami.com");

SPI_Init();

USART_PutString("\r");
USART_PutString("*************************\r");
USART_PutString("**     ZL28ARM  TC77   **\r");
USART_PutString("**    www.kamami.com   **\r");
USART_PutString("*************************\r");
for(i = 0; i < 0x1FFFFF; i++);
LCD_GoTo(0,1);
LCD_WriteText("                ");


do{
	A1 = SPI_Transmit(0); // read byte
	A2 = SPI_Transmit(0); // read byte

	temp = ((A1 << 8) | A2);
	itoa((temp >> 7), strTemp);
	fract = ((temp >> 3) & 0x0F);

	USART_PutString("\rTC77 output (hex): ");
	USART_PutString(Hex(A1,str)); // convert to hex and send 
	USART_PutString(Hex(A2,str)); // convert to hex and send
	USART_PutChar('\r');
	USART_PutString("Temperature : ");
	USART_PutString(strTemp);  	
	USART_PutChar('.');
	USART_PutChar(fractConst[fract]);
	USART_PutChar(0xB0);
	USART_PutChar('C');

	LCD_GoTo(0,1);
	LCD_WriteText("Temp: ");
	LCD_WriteText(strTemp);
	LCD_WriteData('.');
	LCD_WriteData(fractConst[fract]);
	for(i = 0; i < 0x1FFFFF; i++);
}
while(1);
return 0;
}
