//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www kamami.com
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
#include "HD44780.h"
#include "board.h"
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
#define LCD_GPIO AT91C_BASE_PIOA

#define LCD_D4 AT91C_PIO_PB22
#define LCD_D5 AT91C_PIO_PB23
#define LCD_D6 AT91C_PIO_PB24
#define LCD_D7 AT91C_PIO_PB25

#define LCD_RS AT91C_PIO_PB19
//#define LCD_RW AT91C_PIO_PB23
#define LCD_EN AT91C_PIO_PB21

//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
void LCD_WriteNibble(unsigned char nibbleToWrite)
{
AT91F_PIO_SetOutput(LCD_GPIO, LCD_EN);
(nibbleToWrite & 1) ? AT91F_PIO_SetOutput(LCD_GPIO, LCD_D4) : AT91F_PIO_ClearOutput(LCD_GPIO, LCD_D4);
(nibbleToWrite & 2) ? AT91F_PIO_SetOutput(LCD_GPIO, LCD_D5) : AT91F_PIO_ClearOutput(LCD_GPIO, LCD_D5);
(nibbleToWrite & 4) ? AT91F_PIO_SetOutput(LCD_GPIO, LCD_D6) : AT91F_PIO_ClearOutput(LCD_GPIO, LCD_D6);
(nibbleToWrite & 8) ? AT91F_PIO_SetOutput(LCD_GPIO, LCD_D7) : AT91F_PIO_ClearOutput(LCD_GPIO, LCD_D7);
AT91F_PIO_ClearOutput(LCD_GPIO, LCD_EN);
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
void LCD_WriteData(char dataToWrite)
{
volatile unsigned int delayCnt = 0;
AT91F_PIO_SetOutput(LCD_GPIO, LCD_RS);
LCD_WriteNibble(dataToWrite >> 4);
LCD_WriteNibble(dataToWrite & 0x0F);
for(delayCnt = 0;delayCnt < 10000; delayCnt++);
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
void LCD_WriteCommand(char commandToWrite)
{
volatile unsigned int delayCnt = 0;
AT91F_PIO_ClearOutput(LCD_GPIO, LCD_RS);
LCD_WriteNibble(commandToWrite >> 4);
LCD_WriteNibble(commandToWrite & 0x0F);
for(delayCnt = 0;delayCnt < 10000; delayCnt++);
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
void LCD_WriteText(char * text)
{
while((*text != 0)&&(*text != 13))
  LCD_WriteData(*text++);
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
void LCD_GoTo(unsigned char x, unsigned char y)
{
LCD_WriteCommand(HD44780_DDRAM_SET | (x + (0x40 * y)));
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
void LCD_WriteTextXY(char * text, char x, char y)
{
LCD_GoTo(x,y);
while((*text != 0)&&(*text != 13))
  LCD_WriteData(*text++);
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
void LCD_WriteBinary(unsigned int var, char bitCount)
{
signed char i;

for(i = (bitCount - 1); i >= 0; i--)
   {
   LCD_WriteData((var & (1 << i))?'1':'0');
   }
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
void LCD_ShiftLeft(void)
{
LCD_WriteCommand(HD44780_DISPLAY_CURSOR_SHIFT | HD44780_SHIFT_LEFT | HD44780_SHIFT_DISPLAY);
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
void LCD_ShiftRight(void)
{
LCD_WriteCommand(HD44780_DISPLAY_CURSOR_SHIFT | HD44780_SHIFT_RIGHT | HD44780_SHIFT_DISPLAY);
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
void LCD_Clear(void)
{
LCD_WriteCommand(HD44780_CLEAR);
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
void LCD_Initialize(void)
{
volatile unsigned char i = 0;
volatile unsigned int delayCnt = 0;


AT91F_PIO_CfgOutput(LCD_GPIO, LCD_D4 | LCD_D5 | LCD_D6 | LCD_D7 | LCD_EN | LCD_RS);
AT91F_PIO_ClearOutput(LCD_GPIO, LCD_EN | LCD_RS);

for(delayCnt = 0; delayCnt < 300000; delayCnt++);

for(i = 0; i < 3; i++)              
  {
  LCD_WriteNibble(0x03);            
  for(delayCnt = 0;delayCnt < 70000; delayCnt++);
  }

LCD_WriteNibble(0x02);             

for(delayCnt = 0;delayCnt < 30000; delayCnt++);
   
LCD_WriteCommand(HD44780_FUNCTION_SET | 
                 HD44780_FONT5x7 | 
                 HD44780_TWO_LINE | 
                 HD44780_4_BIT);

LCD_WriteCommand(HD44780_DISPLAY_ONOFF | 
                 HD44780_DISPLAY_OFF); 

LCD_WriteCommand(HD44780_CLEAR); 

LCD_WriteCommand(HD44780_ENTRY_MODE | 
                 HD44780_EM_SHIFT_CURSOR | 
                 HD44780_EM_INCREMENT);

LCD_WriteCommand(HD44780_DISPLAY_ONOFF | 
                 HD44780_DISPLAY_ON |
                 HD44780_CURSOR_OFF | 
                 HD44780_CURSOR_NOBLINK);

}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
